;**********************************************************************
;
;              FINITE IMPULSE RESPONSE (FIR)
;            LINEAR PHASE DIGITAL FILTER DESIGN
;                REMEZ EXCHANGE ALGORITHM
;
;                      BEL-202 IC-271 EQ FILTER
;
;                   FILTER LENGTH =  41
;
;              ***** IMPULSE RESPONSE *****
;         H( 1) =   -1481.923 = H( 41)
;         H( 2) =   -2793.154 = H( 40)
;         H( 3) =    1526.122 = H( 39)
;         H( 4) =    -522.255 = H( 38)
;         H( 5) =    -411.561 = H( 37)
;         H( 6) =     442.016 = H( 36)
;         H( 7) =     677.701 = H( 35)
;         H( 8) =    -900.867 = H( 34)
;         H( 9) =    -508.719 = H( 33)
;         H(10) =     938.531 = H( 32)
;         H(11) =      70.969 = H( 31)
;         H(12) =    -586.158 = H( 30)
;         H(13) =     827.322 = H( 29)
;         H(14) =     -87.252 = H( 28)
;         H(15) =   -2145.014 = H( 27)
;         H(16) =     888.400 = H( 26)
;         H(17) =    3609.433 = H( 25)
;         H(18) =   -1846.721 = H( 24)
;         H(19) =   -4772.972 = H( 23)
;         H(20) =    5294.121 = H( 22)
;         H(21) =   13409.030 = H( 21)

;                       BAND  1       BAND  2       BAND  3
; LOWER BAND EDGE      .0000000      .1800000      .3000000
; UPPER BAND EDGE      .1700000      .2900000      .5000000
; DESIRED VALUE        .5000000     1.0000000      .0000000
; WEIGHTING           1.0000000     1.0000000     1.0000000
; DEVIATION            .1995433      .1995433      .1995433
; DEVIATION IN DB    -3.1037080     1.5803180   -13.9992600

; EXTREMAL FREQUENCIES--MAXIMA OF THE ERROR CURVE
;     .0000000    .0252976    .0505953    .0766369    .1019344
;     .1272320    .1525295    .1700000    .2008333    .2276189
;     .2529164    .2767258    .2900000    .3000000    .3133928
;     .3372023    .3624998    .3892854    .4160710    .4436007
;     .4718744    .5000000

;***********************************************************
;
;
XN:	EQU 0
XNM1:	EQU 1
XNM2:	EQU 2
XNM3:	EQU 3
XNM4:	EQU 4
XNM5:	EQU 5
XNM6:	EQU 6
XNM7:	EQU 7
XNM8:	EQU 8
XNM9:	EQU 9
XNM10:	EQU 10
XNM11:	EQU 11
XNM12:	EQU 12
XNM13:	EQU 13
XNM14:	EQU 14
XNM15:	EQU 15
XNM16:	EQU 16
XNM17:	EQU 17
XNM18:	EQU 18
XNM19:	EQU 19
XNM20:	EQU 20
XNM21:	EQU 21
XNM22:	EQU 22
XNM23:	EQU 23
XNM24:	EQU 24
XNM25:	EQU 25
XNM26:	EQU 26
XNM27:	EQU 27
XNM28:	EQU 28
XNM29:	EQU 29
XNM30:	EQU 30
XNM31:	EQU 31
XNM32:	EQU 32
XNM33:	EQU 33
XNM34:	EQU 34
XNM35:	EQU 35
XNM36:	EQU 36
XNM37:	EQU 37
XNM38:	EQU 38
XNM39:	EQU 39
XNM40:	EQU 40
;
H18:	EQU 50
H19:	EQU 51
H20:	EQU 52
MASK1:	EQU 53
YN:	EQU 54
ONE:	EQU 55
;
	ORG 0
;
	B START
;
; DUE TO THE SYMMETRY OF THE IMPULSE RESPONSE ;
; ONLY HALF OF THE SAMPLES OF THE IMPULSE     ;
; RESPONSE ARE STORED.	THIS MEANS THAT       ;
; h(N-1-n) = h(n).			      ;
;
	dw	-4773
	dw	5294
	dw	13409
ENDC:	dw	0800H
;

START:	LDPK 0
;
	LACK 1
	SACL ONE	; CONTENT OF ONE IS 1 ;
	LARK AR0,MASK1	; THIS SECTION OF CODE LOADS  ;
	LARK AR1,4	; THE FILTER COEFFICIENTS AND ;
	LACK ENDC	; OTHER VALUES FROM PROGRAM   ;
LOAD:	LARP AR0	; MEMORY TO DATA MEMORY       ;
	TBLR *-,AR1
	SUB ONE
	BANZ LOAD
;
WAIT:	BIOZ NXTPT	; BIO PIN GOES LOW WHEN A ;
	B WAIT		; NEW SAMPLE IS AVAILABLE ;
;
NXTPT:	IN XN,PA3	; BRING IN THE NEW SAMPLE XN ;
	LAC XN,4
	SUB ONE,15
	SACL XN,0
;
	ZAC
;
	LT XNM40;
	MPYK -1482
;
	LTD XNM39
	MPYK -2793
;
	LTD XNM38
	MPYK 1526
;
	LTD XNM37
	MPYK -522
;
	LTD XNM36
	MPYK -412
;
	LTD XNM35
	MPYK 442
;
	LTD XNM34
	MPYK 678
;
	LTD XNM33
	MPYK -901
;
	LTD XNM32
	MPYK -509
;
	LTD XNM31
	MPYK 939
;
	LTD XNM30
	MPYK 71
;
	LTD XNM29
	MPYK -586
;
	LTD XNM28
	MPYK 827
;
	LTD XNM27
	MPYK -87
;
	LTD XNM26
	MPYK -2145
;
	LTD XNM25
	MPYK 888
;
	LTD XNM24
	MPYK 3609
;
	LTD XNM23
	MPYK -1847
;
	LTD XNM22
	MPY H18
;
	LTD XNM21
	MPY H19
;
	LTD XNM20
	MPY H20
;
	LTD XNM19
	MPY H19
;
	LTD XNM18
	MPY H18
;
	LTD XNM17
	MPYK -1847
;
	LTD XNM16
	MPYK 3609
;
	LTD XNM15
	MPYK 888
;
	LTD XNM14
	MPYK -2145
;
	LTD XNM13
	MPYK -87
;
	LTD XNM12
	MPYK 827
;
	LTD XNM11
	MPYK -586
;
	LTD XNM10
	MPYK 71
;
	LTD XNM9
	MPYK 939
;
	LTD XNM8
	MPYK -509
;
	LTD XNM7
	MPYK -901
;
	LTD XNM6
	MPYK 678
;
	LTD XNM5
	MPYK 442
;
	LTD XNM4
	MPYK -412
;
	LTD XNM3
	MPYK -522
;
	LTD XNM2
	MPYK 1526
;
	LTD XNM1
	MPYK -2793
;
	LTD XN
	MPYK -1482
;
	APAC
;
	sach yn
	LAC YN,12
	ADDH MASK1
	SACH YN,0
;
	
	OUT YN,PA4	; OUTPUT THE FILTER RESPONSE y(n) ;
;
	B WAIT		; GO GET THE NEXT POINT ;
;
	END
